import grok
import os
from waeup.interfaces import IBaseContainer
#from waeup.baseitem import BaseItem
from waeup.viewlets import MainArea, Index, Add, Edit
from zope.component import getMultiAdapter

class BaseContainer(grok.Container):
    """
    The base container. This is a stub for now. It can have
    base methods and templates attached to it
    """
    grok.implements(IBaseContainer)
    name = u"BaseContainer"
    childClass = None
    specialActions = []
    
class Content(grok.Viewlet):
    """
    Base viewlet
    """
    grok.viewletmanager(MainArea)
    grok.view(Index)
    #grok.order(1)

class AddForm(grok.AddForm):
    template = grok.PageTemplate(filename=os.path.join('basecontainer_templates', 'edit_form.pt'))

    def update(self):
        self.form_fields = grok.AutoFields(self.context.childClass)
        grok.AddForm.update(self)

    @grok.action('Add item')
    def add(self, **data):
        obj = self.context.childClass(**data)
        try:
            name = data['name'].lower().replace(' ', '_')
            self.context[name] = obj
        except Exception, ex:
            print ex
            print data
        self.redirect(self.url())

class Add(grok.Viewlet):
    grok.viewletmanager(MainArea)
    grok.context(IBaseContainer)
    grok.view(Add)
    #grok.order(2)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request),
                                    name='addform')
        self.form.update_form()

    def render(self):
        return self.form.render()
