# baseitem.py
import os
import grok
from waeup.viewlets import MainArea, Index, Add, Edit
from waeup.interfaces import IBaseItem
from zope.component import getMultiAdapter

class BaseItem(grok.Model):
    """
    Base item
    """
    grok.implements(IBaseItem)

class Index(grok.Viewlet):
    grok.viewletmanager(MainArea)
    #grok.context(IBaseItem)
    #grok.order(1)
    #grok.View(Index) # warum gibt das hier einen Fehler?
    grok.template('content')

class AddForm(grok.AddForm):
    template = grok.PageTemplate(filename=os.path.join('basecontainer_templates', 'edit_form.pt'))

    def update(self):
        self.form_fields = grok.AutoFields(self.context.childClass)
        grok.AddForm.update(self)

    @grok.action('Add item')
    def add(self, **data):
        obj = self.context.childClass(**data)
        name = data['name'].lower().replace(' ', '_')
        self.context[name] = obj

class EditForm(grok.EditForm):
    template = grok.PageTemplate(filename=os.path.join('basecontainer_templates', 'edit_form.pt'))
   
    def update(self):
        self.form_fields = grok.AutoFields(self.context.childClass)
        grok.EditForm.update(self)

    @grok.action('Edit item')
    def edit(self, **data):
        obj = self.context.childClass(**data)
        name = data['name'].lower().replace(' ', '_')
        self.context[name] = obj

class Add(grok.Viewlet):
    grok.viewletmanager(MainArea)
    grok.context(IBaseItem)
    grok.view(Add)
    #grok.order(2)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request),
                                    name='addform')
        self.form.update_form()

    def render(self):
        return self.form.render()


class Edit(grok.Viewlet):
    grok.viewletmanager(MainArea)
    grok.context(IBaseItem)
    grok.view(Edit)
    #grok.order(2)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request),
                                    name='editform')
        self.form.update_form()

    def render(self):
        return self.form.render()
